package uoc.integration;

import android.content.SharedPreferences;
import android.content.res.Resources;
import android.preference.PreferenceManager;
import android.support.test.espresso.ViewInteraction;
import android.support.test.filters.LargeTest;
import android.support.test.rule.ActivityTestRule;
import android.support.test.runner.AndroidJUnit4;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import uoc.testlink4android.MainActivity;
import uoc.unit.TestProjectDaoTest;

import static android.support.test.InstrumentationRegistry.getInstrumentation;
import static android.support.test.espresso.Espresso.onView;
import static android.support.test.espresso.action.ViewActions.click;
import static android.support.test.espresso.matcher.ViewMatchers.withText;
import static uoc.unit.SampleDataConstants.PROYECTO_01;


@RunWith(AndroidJUnit4.class)
@LargeTest
public class TestProjectView {

    @Rule
    public ActivityTestRule<MainActivity> mActivityRule = new ActivityTestRule<>(
            MainActivity.class);
    public MainActivity mActivity = null;
    Resources resources = null;
    TestSlideMenu testSlideMenu = null;

    public TestProjectView() {
        this.testSlideMenu = new TestSlideMenu();
        this.resources = getInstrumentation().getTargetContext().getResources();
    }

    @BeforeClass
    public static void setUpBeforeClass() throws Exception {
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(getInstrumentation().getTargetContext());
        prefs.edit().clear();
        prefs.edit().commit(); // I am pretty sure this is not necessary but not harmful either.

        try {
            TestProjectDaoTest testProjectDaoTest = new TestProjectDaoTest();
            testProjectDaoTest.setUp();
            testProjectDaoTest.testAddTestProjects();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Before
    public void setup() {
        testSlideMenu.testOpenFilterProjects();
    }

    @Test
    public void showProjects() {
        ViewInteraction testplanList_project01 = onView(withText("PRYCT01\n" + PROYECTO_01));
        testplanList_project01.perform(click());

        // Type text and then press the button.
//        ViewInteraction testplanList_project02 = onView(withText(PROYECTO_02));
//        testplanList_project02.perform(click());
    }

}