package uoc.unit;

import android.content.Context;
import android.support.test.InstrumentationRegistry;
import android.support.test.runner.AndroidJUnit4;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.ArrayList;
import java.util.List;

import uoc.testlink4android.db.Database;
import uoc.testlink4android.db.schemas.ITestCaseSchema;
import uoc.testlink4android.models.TestCase;
import uoc.testlink4android.testlink.constants.ExecutionStatus;
import uoc.testlink4android.testlink.constants.ExecutionType;
import uoc.testlink4android.testlink.constants.TestCaseStatus;
import uoc.testlink4android.testlink.constants.TestImportance;

import static junit.framework.Assert.assertEquals;

/**
 * Created by haivision on 03/01/2017.
 */
@RunWith(AndroidJUnit4.class)

public class TestCaseDaoTest {

    public static final String TEST_CASE_03 = "TestCase03";
    private Database databaseAccess;

    public TestCaseDaoTest() {
        super();
    }

    @Before
    public void setUp() throws Exception {
        Context instrumantationCtx = InstrumentationRegistry.getTargetContext();
        this.databaseAccess = Database.getInstance(instrumantationCtx);
        this.databaseAccess.clear();
        System.out.println(ITestCaseSchema.TESTCASE_TABLE_CREATE);
    }

    @After
    public void tearDown() throws Exception {
        databaseAccess.clear();
    }

    @Test
    public void testAddTestcases() {
        TestCase tp01 = new TestCase(1, SampleDataConstants.TEST_CASE_01, 1, 1, "fosuna01",
                "summary01", null, "preconditions01", TestCaseStatus.FINAL,
                TestImportance.HIGH, ExecutionType.MANUAL, 1, 1,
                1, "TC01", false, null, 1, 1, 1, null, ExecutionStatus.NOT_RUN, null, 1);

        TestCase tp02 = new TestCase(2, SampleDataConstants.TEST_CASE_02, 1, 1, "fosuna01",
                "summary02", null, "preconditions02", TestCaseStatus.FINAL,
                TestImportance.HIGH, ExecutionType.MANUAL, 1, 1,
                1, "TC02", false, null, 1, 1, 1, null, ExecutionStatus.NOT_RUN, null, 1);

        TestCase tp03 = new TestCase(3, TEST_CASE_03, 1, 1, "fosuna01",
                "summary03", null, "preconditions03", TestCaseStatus.FINAL,
                TestImportance.HIGH, ExecutionType.MANUAL, 1, 1,
                1, "TC03", false, null, 1, 1, 1, null, ExecutionStatus.NOT_RUN, null, 1);

        List<TestCase> testCases = new ArrayList<>(3);
        testCases.add(tp01);
        testCases.add(tp02);
        testCases.add(tp03);

        this.databaseAccess.mTestCaseDao.addTestCases(testCases, 1);

        List<TestCase> savedTestCases = this.databaseAccess.mTestCaseDao.fetchTestCasesByTestPlanId(1);

        assertEquals(savedTestCases.size(), testCases.size());

        int index = 0;
//        for (TestCase testPlan : savedTestCases) {
//            assertEquals(testPlan, testCases.get(index));
//            index++;
//        }
    }
}