package uoc.unit;

import android.content.Context;
import android.support.test.InstrumentationRegistry;
import android.support.test.runner.AndroidJUnit4;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.Date;
import java.util.List;

import uoc.testlink4android.db.Database;
import uoc.testlink4android.db.schemas.IExecutionSchema;
import uoc.testlink4android.models.Execution;
import uoc.testlink4android.testlink.constants.ExecutionStatus;
import uoc.testlink4android.testlink.constants.ExecutionType;

import static junit.framework.Assert.assertEquals;

@RunWith(AndroidJUnit4.class)
public class TestExecutionDao {
    private Database databaseAccess;

    @Before
    public void setUp() throws Exception {
        Context instrumantationCtx = InstrumentationRegistry.getTargetContext();
        this.databaseAccess = Database.getInstance(instrumantationCtx);
        this.databaseAccess.clear();
        System.out.println(IExecutionSchema.EXECUTION_TABLE_CREATE);
    }

    @After
    public void tearDown() throws Exception {
        databaseAccess.clear();
    }

    //    public Execution(Integer id, Integer buildId, Integer testerId, Date executionTimeStamp, ExecutionStatus status,
//                     Integer testPlanId, Integer testCaseVersionId, Integer testCaseVersionNumber, ExecutionType executionType,
//                     String notes) {
    @Test
    public void testAddExecutions() {
        Execution execution01 = new Execution(1, 1, 1, 1, new Date((System.currentTimeMillis() / 1000L) * 1000L), ExecutionStatus.PASSED,
                1, 1, 1, ExecutionType.MANUAL, "notes01");
        this.databaseAccess.mExecutionDao.addExecution(execution01, 1);

        Execution execution02 = new Execution(2, 2, 1, 1, new Date((System.currentTimeMillis() / 1000L) * 1000L), ExecutionStatus.FAILED,
                1, 1, 1, ExecutionType.MANUAL, "notes02");
        this.databaseAccess.mExecutionDao.addExecution(execution02, 2);

        Execution execution03 = new Execution(3, 1, 1, 1, new Date((System.currentTimeMillis() / 1000L) * 1000L), ExecutionStatus.PASSED,
                1, 1, 1, ExecutionType.MANUAL, "notes03");
        this.databaseAccess.mExecutionDao.addExecution(execution03, 3);

        Execution execution04 = new Execution(4, 2, 1, 1, new Date((System.currentTimeMillis() / 1000L) * 1000L), ExecutionStatus.PASSED,
                1, 1, 1, ExecutionType.MANUAL, "notes03");
        this.databaseAccess.mExecutionDao.addExecution(execution03, 3);

        List<Execution> savedtestPlans = this.databaseAccess.mExecutionDao.fetchExecutionsByTesCaseId(1);

        assertEquals(savedtestPlans.size(), 4);

        int index = 0;
        for (Execution execution : savedtestPlans) {
            if (execution.getId() == execution01.getId()) {
                assertEquals(execution, execution01);
            } else if (execution.getId() == execution02.getId()) {
                assertEquals(execution, execution02);
            } else if (execution.getId() == execution03.getId()) {
                assertEquals(execution, execution03);
            }
            index++;
        }
    }
}