package uoc.unit;

import android.content.Context;
import android.support.test.InstrumentationRegistry;
import android.support.test.runner.AndroidJUnit4;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.ArrayList;
import java.util.List;

import uoc.testlink4android.db.Database;
import uoc.testlink4android.db.schemas.ITestPlanSchema;
import uoc.testlink4android.models.TestPlan;

import static junit.framework.Assert.assertEquals;

@RunWith(AndroidJUnit4.class)
public class TestPlanDaoTest {
    private Database databaseAccess;

    public TestPlanDaoTest() {
        super();
    }

    @Before
    public void setUp() throws Exception {
        Context instrumantationCtx = InstrumentationRegistry.getTargetContext();
        this.databaseAccess = Database.getInstance(instrumantationCtx);
        this.databaseAccess.clear();
        System.out.println(ITestPlanSchema.TESTPLAN_TABLE_CREATE);
    }

    @After
    public void tearDown() throws Exception {
        databaseAccess.clear();
    }

    //    TestPlan(Integer id, String name, String projectName, String notes, Boolean isActive, Boolean isPublic,
//             List<CustomField> customFields)
    @Test
    public void testAddTestPlans() {
        TestPlan tp01 = new TestPlan(1, SampleDataConstants.TEST_PLAN_01, "PRYCT01", 1, "notas01", true, true, null);

        TestPlan tp02 = new TestPlan(2, SampleDataConstants.TEST_PLAN_02, "PRYCT01", 1, "notas02", true, true, null);

        TestPlan tp03 = new TestPlan(3, SampleDataConstants.TEST_PLAN_03, "PRYCT01", 1, "notas03", true, true, null);

        List<TestPlan> testplans = new ArrayList<>(3);
        testplans.add(tp01);
        testplans.add(tp02);
        testplans.add(tp03);

        this.databaseAccess.mTestPlanDao.addTestPlans(testplans);

        List<TestPlan> savedtestPlans = this.databaseAccess.mTestPlanDao.fetchAllTestPlans();

        assertEquals(savedtestPlans.size(), testplans.size());

        int index = 0;
        for (TestPlan testPlan : savedtestPlans) {
            assertEquals(testPlan, testplans.get(index));
            index++;
        }
    }
}
