package uoc.testlink4android.background;


import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.List;

import uoc.testlink4android.db.Database;
import uoc.testlink4android.models.Build;
import uoc.testlink4android.models.Execution;
import uoc.testlink4android.models.TestCase;
import uoc.testlink4android.models.TestPlan;
import uoc.testlink4android.models.TestProject;
import uoc.testlink4android.testlink.javaapi.TestLinkAPI;

public class PushTestlinkData extends android.os.AsyncTask<java.net.URL, java.lang.Integer, java.lang.String> {
    public AsyncResponse delegate = null;
    private TestLinkAPI testLinkAPI;
    private Context context;

    private PushTestlinkData(AsyncResponse delegate, Context context) {
        super();
        this.delegate = delegate;
        this.context = context;
    }

    public static PushTestlinkData getInstance(AsyncResponse delegate, Context context) {
        return new PushTestlinkData(delegate, context);
    }

    //        public ReportTCResultResponse reportTCResult(Integer testCaseId, Integer testCaseExternalId, Integer testPlanId,
//                                                     ExecutionStatus status, Integer buildId, String buildName, String notes, Boolean guess, String bugId,
//                                                     Integer platformId, String platformName, Map<String, String> customFields, Boolean overwrite)
//                throws TestLinkAPIException {
//            return this.testCaseService.reportTCResult(testCaseId, testCaseExternalId, testPlanId, status, buildId,
//                    buildName, notes, guess, bugId, platformId, platformName, customFields, overwrite);
//        }
//
//        /**
//         * Reports a Test Case result.
//         *
//         * @param testCaseId         test case ID
//         * @param testCaseExternalId test case external ID
//         * @param testPlanId         test plan ID
//         * @param status             status
//         * @param buildId            build ID
//         * @param buildName          build name
//         * @param notes              notes
//         * @param guess              flag to guess other parameters or not
//         * @param bugId              bug ID
//         * @param platformId         platform ID
//         * @param platformName       platform name
//         * @param customFields       custom fields
//         * @param overwrite          flag to overwrite or not
//         * @return response
//         * @throws TestLinkAPIException if the service returns an error
//         */
//        public ReportTCResultResponse setTestCaseExecutionResult(Integer testCaseId, Integer testCaseExternalId,
//                                                                 Integer testPlanId, ExecutionStatus status, Integer buildId, String buildName, String notes, Boolean guess,
//                                                                 String bugId, Integer platformId, String platformName, Map<String, String> customFields, Boolean overwrite)
//                throws TestLinkAPIException {
//            return this.testCaseService.reportTCResult(testCaseId, testCaseExternalId, testPlanId, status, buildId,
//                    buildName, notes, guess, bugId, platformId, platformName, customFields, overwrite);
//        }

    private TestLinkAPI getServerConnection() throws MalformedURLException {
        TestLinkAPI testLinkAPI = null;
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(context);
        String serverURL = prefs.getString("server_URL", "http://192.168.1.44/testlink/lib/api/xmlrpc/v1/xmlrpc.php");
        String userKey = prefs.getString("user_key", "82aef4843220dfaea7417eebbb7a089a");
        Log.d("serverURL", serverURL);
        Log.d("userKey", userKey);
        testLinkAPI = new TestLinkAPI(new URL(serverURL), userKey);
        return testLinkAPI;
    }

    protected String doInBackground(URL... urls) {
        String result = null;
        try {
            this.testLinkAPI = getServerConnection();

            if (this.testLinkAPI != null) {
                Database databaseAccess = Database.getInstance(context);
                TestProject[] testProjects = this.testLinkAPI.getProjects();
                List<TestProject> testProject = databaseAccess.mTestProjectDao.fetchAllTestProjects();
                for (TestProject project : testProject) {
                    List<TestPlan> testPlans = databaseAccess.mTestPlanDao.fetchTestPlansByProjectId(project.getId());
                    for (TestPlan testPlan : testPlans) {
                        List<Build> builds = databaseAccess.mBuilDao.fetchTestplanBuilds(testPlan.getId());
                        for (Build build : builds) {
                            List<Execution> executions = databaseAccess.mExecutionDao.fetchExecutions(testPlan.getId(), build.getId());
                            for (Execution execution : executions) {
                                TestCase testCase = databaseAccess.mTestCaseDao.fetchTestCaseById(execution.getTestCaseId());
                                this.testLinkAPI.reportTCResult(testCase.getId(), testCase.getVersionId(), testPlan.getId(),
                                        execution.getStatus(), execution.getBuildId(), build.getName(), execution.getNotes(), false, null,
                                        testCase.getPlatform() == null ? null : testCase.getPlatform().getId(), testCase.getPlatform() == null ? null : testCase.getPlatform().getName(), new HashMap<String, String>(0), true);
                            }
                        }
                    }
                }
            }
        } catch (MalformedURLException ex) {
            result = "The URL provided to access testlink server is incorrect";
        } catch (Exception ex) {
            Log.d("XMLRPC01", "", ex);
            result = ex.getMessage();
        }
        return result;
    }

    protected void onProgressUpdate(Integer... progress) {
    }

    protected void onPostExecute(Long result) {
    }


    public void onPostExecute(String result) {
        delegate.processFinish(result);
    }
}
