package uoc.testlink4android.db.schemas;


public interface ICustomFieldSchema {
    public static String CUSTOMFIELD_TABLE = "customfield";
    public static String COLUMN_ID = "_id";
    public static String COLUMN_NAME = "name";
    public static String COLUMN_LABEL = "label";
    public static String COLUMN_TYPE = "type";
    public static String COLUMN_POSSIBLE_VALUES = "possibleValues";
    public static String COLUMN_DEFAULT_VALUE = "defaultValue";
    public static String COLUMN_VALID_REGEXP = "validRegexp";
    public static String COLUMN_LENGTH_MIN = "lengthMin";
    public static String COLUMN_LENGTH_MAX = "lengthMax";
    public static String COLUMN_SHOW_ON_DESIGN = "showOnDesign";
    public static String COLUMN_ENABLE_ON_DESIGN = "enableOnDesign";
    public static String COLUMN_SHOW_ON_EXECUTION = "showOnExecution";
    public static String COLUMN_ENABLE_ON_EXECUTION = "enableOnExecution";
    public static String COLUMN_SHOW_ON_TEST_PLAN_DESIGN = "showOnTestPlanDesign";
    public static String COLUMN_ENABLE_ON_TEST_PLAN_DESIGN = "enableOnTestPlanDesign";
    public static String COLUMN_DISPLAY_ORDER = "displayOrder";
    public static String COLUMN_LOCATION = "location";
    public static String COLUMN_VALUE = "value";
    public static String COLUMN_TEST_CASE_ID = "testCaseId";

    public static String CUSTOMFIELD_TABLE_CREATE = "CREATE TABLE IF NOT EXISTS "
            + CUSTOMFIELD_TABLE
            + " ("
            + COLUMN_ID
            + " INTEGER PRIMARY KEY, "
            + COLUMN_NAME
            + " TEXT, "
            + COLUMN_LABEL
            + " TEXT,"
            + COLUMN_TYPE
            + " INTEGER, "
            + COLUMN_POSSIBLE_VALUES
            + " TEXT, "
            + COLUMN_DEFAULT_VALUE
            + " TEXT, "
            + COLUMN_VALID_REGEXP
            + " TEXT, "
            + COLUMN_LENGTH_MIN
            + " INTEGER, "
            + COLUMN_LENGTH_MAX
            + " INTEGER, "
            + COLUMN_SHOW_ON_DESIGN
            + " BOOLEAN, "
            + COLUMN_ENABLE_ON_DESIGN
            + " BOOLEAN, "
            + COLUMN_SHOW_ON_EXECUTION
            + " BOOLEAN, "
            + COLUMN_ENABLE_ON_EXECUTION
            + " BOOLEAN, "
            + COLUMN_SHOW_ON_TEST_PLAN_DESIGN
            + " BOOLEAN, "
            + COLUMN_ENABLE_ON_TEST_PLAN_DESIGN
            + " BOOLEAN, "
            + COLUMN_DISPLAY_ORDER
            + " INTEGER, "
            + COLUMN_LOCATION
            + " INTEGER, "
            + COLUMN_VALUE
            + " TEXT, "
            + COLUMN_TEST_CASE_ID
            + " INTEGER"
            + ")";

    String[] CUSTOMFIELD_COLUMNS = new String[]{COLUMN_ID, COLUMN_NAME, COLUMN_LABEL, COLUMN_TYPE,
            COLUMN_POSSIBLE_VALUES, COLUMN_DEFAULT_VALUE, COLUMN_VALID_REGEXP, COLUMN_LENGTH_MIN,
            COLUMN_LENGTH_MAX, COLUMN_SHOW_ON_DESIGN, COLUMN_ENABLE_ON_DESIGN, COLUMN_SHOW_ON_EXECUTION,
            COLUMN_ENABLE_ON_EXECUTION, COLUMN_SHOW_ON_TEST_PLAN_DESIGN,
            COLUMN_ENABLE_ON_TEST_PLAN_DESIGN, COLUMN_DISPLAY_ORDER, COLUMN_LOCATION, COLUMN_VALUE, COLUMN_TEST_CASE_ID};
}
