/*
 * The MIT License
 *
 * Copyright (c) 2010 Bruno P. Kinoshita http://www.kinoshita.eti.br
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package uoc.testlink4android.testlink.constants;

/**
 * @author Bruno P. Kinoshita - http://www.kinoshita.eti.br
 * @since 0.1
 */
public enum ActionOnDuplicate {

    BLOCK("block"), GENERATE_NEW("generate_new"), CREATE_NEW_VERSION("create_new_version");

    private String value;

    ActionOnDuplicate(String value) {
        this.value = value;
    }

    public static ActionOnDuplicate getActionOnDuplicate(String actionOnDuplicate) {
        ActionOnDuplicate result = GENERATE_NEW;
        if (actionOnDuplicate != null) {
            if (actionOnDuplicate.equalsIgnoreCase(BLOCK.getValue())) {
                result = BLOCK;
            } else if (actionOnDuplicate.equalsIgnoreCase(GENERATE_NEW.getValue())) {
                result = GENERATE_NEW;
            } else if (actionOnDuplicate.equalsIgnoreCase(CREATE_NEW_VERSION.getValue())) {
                result = CREATE_NEW_VERSION;
            }
        }
        return result;
    }

    public String getValue() {
        return this.value;
    }

    /*
     * (non-Javadoc)
     *
     * @see java.lang.Enum#toString()
     */
    @Override
    public String toString() {
        return getValue();
    }

}
