/*
 * The MIT License
 *
 * Copyright (c) 2010 Bruno P. Kinoshita http://www.kinoshita.eti.br
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package uoc.testlink4android.testlink.constants;

/**
 * @author Mario Fuentes - http://www.rhiscom.com
 * @since 1.9.3-4
 */
public enum TestCaseStatus {

    FINAL(7), FUTURE(6), OBSOLETE(5), REWORK(4), REVIEW_IN_PROGRESS(3), READY_FOR_REVIEW(2), DRAFT(1);

    private Integer value;

    TestCaseStatus(Integer value) {
        this.value = value;
    }

    public static TestCaseStatus getTestCaseStatus(Integer testCaseStatus) {
        TestCaseStatus result = null;
        if (testCaseStatus != null) {
            switch (testCaseStatus) {
                case 1:
                    result = DRAFT;
                    break;
                case 2:
                    result = READY_FOR_REVIEW;
                    break;
                case 3:
                    result = REVIEW_IN_PROGRESS;
                    break;
                case 4:
                    result = REWORK;
                    break;
                case 5:
                    result = OBSOLETE;
                    break;
                case 6:
                    result = FUTURE;
                    break;
                case 7:
                    result = FINAL;
                    break;
            }
        }
        return result;
    }

    public Integer getValue() {
        return value;
    }

    public String toString() {
        return this.value.toString();
    }

}
