package uoc.testlink4android.ui.fragment;

import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.PreferenceFragment;
import android.preference.PreferenceManager;
import android.util.Log;

import uoc.testlink4android.R;


public class PreferencesView extends PreferenceFragment implements SharedPreferences.OnSharedPreferenceChangeListener {
    private static String SERVER_URL = "http://192.168.1.44/testlink/lib/api/xmlrpc/v1/xmlrpc.php";
    private static String USER_KEY = "82aef4843220dfaea7417eebbb7a089a";

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        addPreferencesFromResource(R.xml.preferences_view);
        // Load the preferences from an XML resource
        getPreferenceScreen().getSharedPreferences()
                .registerOnSharedPreferenceChangeListener(this);
        collectPreferencesValues();
    }

    private void collectPreferencesValues() {
        SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(getContext());
        SharedPreferences.Editor prefEditor = prefs.edit();

        String serverURL = prefs.getString("server_URL", SERVER_URL);
        if (serverURL.equals("")) {
            serverURL = SERVER_URL;
        }

        String userKey = prefs.getString("user_key", USER_KEY);
        if (userKey.equals("")) {
            userKey = USER_KEY;
        }

        Preference pref = findPreference("server_URL");
        pref.setSummary(serverURL);
        prefEditor.putString("server_URL", serverURL);

        pref = findPreference("user_key");
        pref.setSummary(userKey);
        prefEditor.putString("user_key", userKey);
        prefEditor.commit();
        Log.d("serverURL", serverURL);
        Log.d("userKey", userKey);
    }

    @Override
    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {
        collectPreferencesValues();
    }

}
