package uoc.integration;


import android.content.Intent;
import android.support.test.espresso.ViewInteraction;
import android.support.test.filters.LargeTest;
import android.support.test.rule.ActivityTestRule;
import android.support.test.runner.AndroidJUnit4;

import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;
import org.junit.runner.RunWith;

import uoc.testlink4android.MainActivity;
import uoc.testlink4android.R;
import uoc.unit.TestCaseDaoTest;
import uoc.unit.TestPlanDaoTest;
import uoc.unit.TestProjectDaoTest;

import static android.support.test.espresso.Espresso.onView;
import static android.support.test.espresso.action.ViewActions.click;
import static android.support.test.espresso.assertion.ViewAssertions.matches;
import static android.support.test.espresso.contrib.DrawerActions.open;
import static android.support.test.espresso.matcher.ViewMatchers.hasSibling;
import static android.support.test.espresso.matcher.ViewMatchers.isDisplayed;
import static android.support.test.espresso.matcher.ViewMatchers.withId;
import static android.support.test.espresso.matcher.ViewMatchers.withText;
import static org.hamcrest.Matchers.allOf;
import static uoc.unit.SampleDataConstants.TEST_PLAN_01;
import static uoc.unit.SampleDataConstants.TEST_PLAN_02;

@RunWith(AndroidJUnit4.class)
@LargeTest
public class OpenTestPlan {
    @Rule
    public ActivityTestRule<MainActivity> mActivityRule = new ActivityTestRule<>(
            MainActivity.class);
    public MainActivity mActivity = null;

    TestPlanDaoTest testPlanDaoTest;
    TestProjectDaoTest testProjectDaoTest;
    TestCaseDaoTest testCaseDaoTest;

    @Before
    public void initValidString() {
        // Specify a valid string.
        try {
            testProjectDaoTest = new TestProjectDaoTest();
            testProjectDaoTest.setUp();
            testProjectDaoTest.testAddTestProjects();
            testPlanDaoTest = new TestPlanDaoTest();
            testPlanDaoTest.testAddTestPlans();
            testCaseDaoTest = new TestCaseDaoTest();
            testCaseDaoTest.testAddTestcases();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Test
    public void showTestplanDetails() {
        Intent intent = new Intent(Intent.ACTION_PICK);
        this.mActivity = mActivityRule.launchActivity(intent);
        // Type text and then press the button.
        ViewInteraction testplanList_testPlan01 = onView(withText(TEST_PLAN_01));
        testplanList_testPlan01.perform(click());

        ViewInteraction testPlan01_details = onView(withId(R.id.item_testplan_summary));
        testPlan01_details.check(matches(isDisplayed()));

        ViewInteraction slideMenu = onView(withId(R.id.activity_main)).perform(open());
//        ViewInteraction testPlanItem =  slideMenu.perform(click(withText("Test plans")));
//        testPlanItem.perform(click());
        onView(allOf(withId(R.id.item_title), hasSibling(withText("Test plans")))).perform(click());

        // Type text and then press the button.
        ViewInteraction testplanList_testPlan02 = onView(withText(TEST_PLAN_02));
        testplanList_testPlan02.perform(click());

//        ViewInteraction testPlan02_details = onView(withId(R.id.item_testplan_summary));
//        testPlan01_details.check(matches(isDisplayed()));

    }

//    @Test
//    public void showTestplanDetails() {
//        Intent intent = new Intent(Intent.ACTION_PICK);
//        this.mActivity = mActivityRule.launchActivity(intent);
//        // Type text and then press the button.
//        ViewInteraction testplanList_testPlan01 = onView(withText(TEST_PLAN_01));
//        testplanList_testPlan01.perform(click());
//
//        ViewInteraction testPlan01_details = onView(withId(R.id.item_testplan_summary));
//        testPlan01_details.check(matches(isDisplayed()));
////        testPlan01_details.check(matches(withChild("TESTPLAN"));
//
////        withParent(R. Matcher<View> parentMatcher)
////        onView(withId(2)).perform(click());
////        testAddTestPlans();
////
////        // Check that the text was changed.
////        onView(withId(R.id.textToBeChanged))
////                .check(matches(withText(mStringToBetyped)));
//    }

}
